/*
 *		      PAIR_UM.C  MS Johnson  24-06-1990
 *
 *			     Copyright (c) 1990
 *
 *	NOT TO BE COPIED OR SOLD UNDER ANY CIRCUMSTANCES WITHOUT THE
 *			  PERMISSION OF THE AUTHOR
 *
 *	multiple alignment program developed by the author at home
 *	and with his own resources.
 *
 *
 *
 */

                /*
		 *  file = Sequences to be aligned.
		 */

#include <stdio.h>
#include "malign.h"

extern int matrix[MAX_LEN][MAX_LEN];
extern int temp[2][MAX_LEN];
extern char seq[MAX_SEQ][MAX_LEN];
extern int r_f;
extern int s_flag;
extern int seg;


int align[2][MAX_LEN];
int GAP2[MAX_LEN][MAX_LEN];		/* scoring matrices */
int GAP1[MAX_LEN][MAX_LEN];
int GAP0[MAX_LEN][MAX_LEN];
int S2[MAX_LEN][MAX_LEN];

int c;
int j, k;

int pair_um(lenj,lenk,pen,t_len,wgt)

int lenj;
int lenk;
int pen;
int *t_len;
int wgt;

{
register int jj, kk, i, l;
int m, n;
int t;
int sigma;
int dum1, dum2, GAP0max;
int score, maxp, maxq;
int S1;
int aver2;
float fscore;

/*
 *	if s_flag == TRUE; compute all possible segment comparison scores
 *	then assign average score to entire segment; in so doing
 *	create a template X sequence matrix that contains these
 *	segment scores; then apply dynamic programming to this
 *	matrix;
 */

if(s_flag==TRUE)
	{
	for(j=1;j<=lenj;++j)
		{
		for(k=1;k<=(lenk-seg)+1;++k)
			{
			S1=0;
			for(l=0;l<seg;l++)
				{
				S1+= (int)(((float)matrix[j][k]/(float)wgt)+0.5);
				}

			/* norm for elements in segment */

			aver2 = (int)((float)S1 / (float)seg +0.5);

			for(l=0;l<seg;l++)
				if(S2[j+l][k+l]<aver2)
					S2[j+l][k+l]=aver2;
			}
		}
	}

else	{
	for(j=1;j<=lenj;++j)
		{
		for(k=1;k<=lenk;++k)
			{
			S2[j][k]= (int)(((float)matrix[j][k]/(float)wgt)+0.5);
			}
		}
	}

/* 
 *	initialize matrices
 */

for( j=0; j<=lenj; ++j ) GAP2[j][0] = GAP1[j][0] = GAP0[j][0] = 0;
for( k=0; k<=lenk; ++k ) GAP2[0][k] = GAP1[0][k] = GAP0[0][k] = 0;

/*
 *	score all possible residue matches
 */

for( j=1; j<=lenj; ++j )
	{
	jj = j - 1;
	for( k=1; k<=lenk; ++k )
		{
		kk = k - 1;

	/*	sigma = matrix[j][k];*/

		sigma = S2[j][k];

		/* determine GAP0[j][k] */

		GAP0max = GAP0[jj][kk];
		dum1 = GAP2[jj][kk] - pen;
		dum2 = GAP1[jj][kk] - pen;
		if( GAP0max < dum1 )
			{
			GAP0max = dum1;
			}
		if( GAP0max < dum2 )
			{
			GAP0max = dum2;
			}
		GAP0[j][k] = GAP0max + sigma;

		/* determine GAP2[j][k] */

		GAP2[j][k] = GAP2[jj][k];
		if( GAP2[jj][k] < GAP0[jj][k] )
			GAP2[j][k] = GAP0[jj][k];

		/* determine GAP1[j][k] */

		GAP1[j][k] = GAP1[j][kk];
		if( GAP1[j][kk] < GAP0[j][kk] )
			GAP1[j][k] = GAP0[j][kk];
		}
	}

/*
 *	locate high edge value
 */

m = lenj;
n = lenk;

score = GAP1[m][n];

if(score < GAP2[m][n])score = GAP2[m][n];
if(score < GAP0[m][n])score = GAP0[m][n];

/*
 *	follow the yellow brick road ...
 */

j = m;
k = n;
c = 1;
if( score == GAP0[j][k] )
	{
	align[0][c] = j;
	align[1][c] = k;
	c++;
	GAP0_trace(pen);
	}

else if( score == GAP2[j][k] )
	{
	align[0][c] = j;
	align[1][c] = -99;
	c++;
	GAP2_trace(pen);
	}

else	{
	align[0][c] = -99;
	align[1][c] = k;
	c++;
	GAP1_trace(pen);
	}

/*
 *	fill in the beginning of alignment
 */

if(j==1){
	while(k-1 >=1)
	/*while(k>-1)*/
		{
		align[0][c] = -99;
		align[1][c++] = --k;
		if(c>=MAX_LEN-1)trouble();
		}
	}

if(k==1){
	while(j-1 >=1)
	/*while(j>-1)*/
		{
		align[0][c] = --j;
		align[1][c++] = -99;
		if(c>=MAX_LEN-1)trouble();
		}
	}
k=1;
c-= 1;
/* c-= 3*/
for(i=c;i>0;i--)
	{
	temp[0][k]=align[0][i];
	temp[1][k]=align[1][i];
	k++;
	}
*t_len=c;

return(score);
}

GAP0_trace(pen)

int pen;
{
int GAP0_max;

if(j==1 || k==1) return;

j--;
k--;

GAP0_max = GAP0[j][k];
if(GAP0_max < GAP2[j][k]- pen)GAP0_max = GAP2[j][k]- pen;
if(GAP0_max < GAP1[j][k]- pen)GAP0_max = GAP1[j][k]- pen;

if(GAP0_max == GAP0[j][k])
	{
	align[0][c] = j;
	align[1][c] = k;
	c++;
	if(c>=MAX_LEN-1)trouble();
	GAP0_trace(pen);
	return;
	}

else if(GAP0_max == (GAP2[j][k] - pen))
	{
	align[0][c] = j;
	align[1][c] = -99;
	c++;
	if(c>=MAX_LEN-1)trouble();
	GAP2_trace(pen);
	return;
	}

else	{
	align[0][c] = -99;
	align[1][c] = k;
	c++;
	if(c>=MAX_LEN-1)trouble();
	GAP1_trace(pen);
	return;
	}
}



GAP2_trace(pen)

int pen;
{

if(j==1)return;

j--;
align[0][c] = j;

if(GAP2[j][k] > GAP0[j][k])
	{
	align[1][c] = -99;
	c++;
	if(c>=MAX_LEN-1)trouble();
	GAP2_trace(pen);
	return;
	}

else	{
	align[1][c] = k;
	c++;
	if(c>=MAX_LEN-1)trouble();
	GAP0_trace(pen);
	return;
	}
}



GAP1_trace(pen)

int pen;
{

if(k==1)return;

k--;

align[1][c] = k;

if(GAP1[j][k] > GAP0[j][k])
	{
	align[0][c] = -99;
	c++;
	if(c>=MAX_LEN-1)trouble();
	GAP1_trace(pen);
	return;
	}

else	{
	align[0][c] = j;
	c++;
	if(c>=MAX_LEN-1)trouble();
	GAP0_trace(pen);
	return;
	}
}

trouble()
{
fprintf(stderr,"\n\n(FATAL)\n\n");
fprintf(stderr,"Exceeded %d residues in",MAX_LEN-52);
fprintf(stderr," alignment\n\n");
fprintf(stderr,"Increase MAX_LEN to desired size ");
fprintf(stderr,"and recompile programs\n\n");
exit(-5);
}
