/*
 *		      READ_UM.C  MS Johnson  24-06-1990
 *
 *			     Copyright (c) 1990
 *
 *	NOT TO BE COPIED OR SOLD UNDER ANY CIRCUMSTANCES WITHOUT THE
 *			  PERMISSION OF THE AUTHOR
 *
 *	Multiple alignment program developed by the author at home
 *	and with his own resources.
 *
 *
 *
 */

                /*
		 *  file = Sequences to be aligned.
		 */

#include <stdio.h>
#include <ctype.h>
#include "malign.h"

extern char code[MAX_SEQ][MAX_CDE];
extern char title[MAX_SEQ][MAX_TIT];
extern char seq[MAX_SEQ][MAX_LEN];
extern int len[MAX_SEQ];
extern int ren[MAX_SEQ];


int read_um(file)

FILE *file;

{
register int i,j,c;

int s_ct;		/* residue counter */

printf("\n\nSequences:\n");
printf("\n      Code                      Title     ");
printf("                        Length\n");
i=0;
for(;;) {
	if(i>MAX_SEQ)
		{
		fprintf(stderr,"\n\nread_um: number of seqs exceeded %d",
			MAX_SEQ);
		fprintf(stderr,"\n\n");
		exit(-23);
		}

	/* skip over comment lines signified by a ligne beginning with C
           prior to first sequence entry */

	while((c=getc(file))!=EOF)
		{
		if(c=='C' )while((c=getc(file))!='\n');
		else	{
			ungetc(c,file);
			goto out;
			}
		}
	out:;

	/* code */

	j=0;

	/* delete >P1; or >F1; */

	if((c=getc(file))!=EOF)if(c=='>')for(c=0;c<3;c++)getc(file);
	if(c==EOF)break;

	while((c=getc(file))!=EOF)
		{
		if(c=='\n')break;
		else code[i][j++]=c;
		}
	if(c==EOF)break;
	code[i][j]='\0';

	printf("\n[%3d] %-10.10s ",i+1,code[i]);

	/* title */

	j=0;
	while((c=getc(file))!=EOF)
		{
		if(c=='\n')break;
		else title[i][j++]=c;
		}
	if(c==EOF)break;
	title[i][j]='\0';

	printf("%-50.50s",title[i]);

	/* sequence data */

	s_ct=0;
	j=0;
	seq[i][j++]=' ';
	while((c=getc(file))!=EOF)
		{
		if(c=='\n');
		else if(c==' ');
		else if(c=='*')break;
		else if(c=='-')seq[i][j++]='-';
		else if(!isalpha(c));
		else	{
			seq[i][j++]=toupper(c);
			s_ct++;
			}
		if(j==MAX_LEN-52)
			{
			fprintf(stderr,"\n\n(FATAL)\n\n");
			fprintf(stderr,"Exceeded %d residues in",MAX_LEN-52);
			fprintf(stderr," sequence %s\n\n",code[i]);
			fprintf(stderr,"Increase MAX_LEN to desired size +");
			fprintf(stderr," 52 and recompile programs\n\n");
			exit(-4);
			}
		}
	if(c==EOF)break;
	len[i]=j-1;		/* length plus possible gaps */
	printf(" %d",s_ct);
	ren[i]=s_ct;		/* length -- sequence only */
	while((getc(file))!='\n');
	i++;


	}
fflush(stdout);
return(i);
}
